# Uses of Class
org.apache.avro.io.Decoder

Packages that use Decoder
Package
Description
org.apache.avro.data
Interfaces and base classes shared by generic, specific and reflect.
org.apache.avro.generic
A generic representation for Avro data.
org.apache.avro.io
Utilities for Encoding and Decoding Avro data.
org.apache.avro.reflect
Use Java reflection to generate schemas and protocols for existing classes.

## Uses of Decoder in org.apache.avro.data

Methods in org.apache.avro.data with parameters of type Decoder
Modifier and Type
Method
Description
`Object`
Json.ObjectReader.`read(Object reuse, Decoder in)`

## Uses of Decoder in org.apache.avro.generic

Methods in org.apache.avro.generic with parameters of type Decoder
Modifier and Type
Method
Description
`D`
GenericDatumReader.`read(D reuse, Decoder in)`
`protected Object`
GenericDatumReader.`readBytes(Object old, Decoder in)`
Called to read byte arrays.
`protected Object`
GenericDatumReader.`readBytes(Object old, Schema s, Decoder in)`
Called to read byte arrays.
`protected Object`
GenericDatumReader.`readEnum(Schema expected, Decoder in)`
Called to read an enum value.
`protected Object`
GenericDatumReader.`readFixed(Object old, Schema expected, Decoder in)`
Called to read a fixed value.
`protected Object`
GenericDatumReader.`readInt(Object old, Schema expected, Decoder in)`
Called to read integers.
`protected Object`
GenericDatumReader.`readMapKey(Object old, Schema expected, Decoder in)`
Called by the default implementation of `GenericDatumReader.readMap(java.lang.Object, org.apache.avro.Schema, org.apache.avro.io.ResolvingDecoder)` to read a key value.
`protected Object`
GenericDatumReader.`readString(Object old, Decoder in)`
Called to read strings.
`protected Object`
GenericDatumReader.`readString(Object old, Schema expected, Decoder in)`
Called to read strings.
`static void`
GenericDatumReader.`skip(Schema schema, Decoder in)`
Skip an instance of a schema.

## Uses of Decoder in org.apache.avro.io

Subclasses of Decoder in org.apache.avro.io
Modifier and Type
Class
Description
`class`
`BinaryDecoder`
An `Decoder` for binary-format data.
`class`
`JsonDecoder`
A `Decoder` for Avro's JSON data encoding.
`class`
`ParsingDecoder`
Base class for parser-based `Decoder`s.
`class`
`ResolvingDecoder`
`Decoder` that performs type-resolution between the reader's and writer's schemas.
`class`
`ValidatingDecoder`
An implementation of `Decoder` that ensures that the sequence of operations conforms to a schema.
Fields in org.apache.avro.io declared as Decoder
Modifier and Type
Field
Description
`protected Decoder`
ValidatingDecoder.`in`
Methods in org.apache.avro.io with parameters of type Decoder
Modifier and Type
Method
Description
`ValidatingDecoder`
ValidatingDecoder.`configure(Decoder in)`
Re-initialize, reading from a new underlying Decoder.
`void`
FastReaderBuilder.ExecutionStep.`execute(Object record, Decoder decoder)`
`D`
DatumReader.`read(D reuse, Decoder in)`
Read a datum.
`Object`
FastReaderBuilder.FieldReader.`read(Object reuse, Decoder decoder)`
`Object`
FastReaderBuilder.MapReader.`read(Object reuse, Decoder decoder)`
`Object`
FastReaderBuilder.RecordReader.`read(Object reuse, Decoder decoder)`
`ResolvingDecoder`
DecoderFactory.`resolvingDecoder(Schema writer, Schema reader, Decoder wrapped)`
Creates a `ResolvingDecoder` wrapping the Decoder provided.
`ValidatingDecoder`
DecoderFactory.`validatingDecoder(Schema schema, Decoder wrapped)`
Creates a `ValidatingDecoder` wrapping the Decoder provided.

## Uses of Decoder in org.apache.avro.reflect

Methods in org.apache.avro.reflect with parameters of type Decoder
Modifier and Type
Method
Description
`protected abstract T`
CustomEncoding.`read(Object reuse, Decoder in)`
`protected final Date`
DateAsLongEncoding.`read(Object reuse, Decoder in)`
`protected Object`
ReflectDatumReader.`readBytes(Object old, Schema s, Decoder in)`
`protected Object`
ReflectDatumReader.`readInt(Object old, Schema expected, Decoder in)`
`protected Object`
ReflectDatumReader.`readString(Object old, Decoder in)`